/**
 */
package org.etsi.mts.tdl.impl;

import java.lang.reflect.InvocationTargetException;

import java.util.Collection;

import java.util.Iterator;
import java.util.List;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

import org.eclipse.ocl.pivot.evaluation.Executor;
import org.eclipse.ocl.pivot.ids.IdResolver;
import org.eclipse.ocl.pivot.ids.IdResolver.IdResolverExtension;
import org.eclipse.ocl.pivot.library.collection.CollectionAsOrderedSetOperation;
import org.eclipse.ocl.pivot.library.collection.CollectionUnionOperation;
import org.eclipse.ocl.pivot.library.oclany.OclAnyOclAsSetOperation;
import org.eclipse.ocl.pivot.messages.PivotMessages;
import org.eclipse.ocl.pivot.utilities.PivotUtil;
import org.eclipse.ocl.pivot.utilities.ValueUtil;
import org.eclipse.ocl.pivot.values.BagValue;
import org.eclipse.ocl.pivot.values.InvalidValueException;
import org.eclipse.ocl.pivot.values.OrderedSetValue;
import org.eclipse.ocl.pivot.values.SequenceValue;
import org.eclipse.ocl.pivot.values.SequenceValue.Accumulator;
import org.eclipse.ocl.pivot.values.SetValue;
import org.etsi.mts.tdl.Behaviour;
import org.etsi.mts.tdl.Block;
import org.etsi.mts.tdl.ComponentInstance;
import org.etsi.mts.tdl.ExceptionalBehaviour;
import org.etsi.mts.tdl.MultipleCombinedBehaviour;
import org.etsi.mts.tdl.PeriodicBehaviour;
import org.etsi.mts.tdl.TestConfiguration;
import org.etsi.mts.tdl.TestDescription;
import org.etsi.mts.tdl.tdlPackage;
import org.etsi.mts.tdl.tdlTables;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Multiple Combined Behaviour</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link org.etsi.mts.tdl.impl.MultipleCombinedBehaviourImpl#getBlock <em>Block</em>}</li>
 * </ul>
 *
 * @generated
 */
public abstract class MultipleCombinedBehaviourImpl extends CombinedBehaviourImpl implements MultipleCombinedBehaviour
{
	/**
	 * The cached value of the '{@link #getBlock() <em>Block</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getBlock()
	 * @generated
	 * @ordered
	 */
	protected EList<Block> block;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected MultipleCombinedBehaviourImpl()
	{
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass()
	{
		return tdlPackage.Literals.MULTIPLE_COMBINED_BEHAVIOUR;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EList<Block> getBlock()
	{
		if (block == null) {
			block = new EObjectContainmentEList<Block>(Block.class, this, tdlPackage.MULTIPLE_COMBINED_BEHAVIOUR__BLOCK);
		}
		return block;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public EList<ComponentInstance> getParticipatingComponents()
	{
		/**
		 *
		 * if
		 *   self.getParentTestDescription()
		 *   ->exists(td | td.isLocallyOrdered)
		 * then
		 *   self.periodic.getParticipatingComponents()
		 *   ->union(self.exceptional.getParticipatingComponents())
		 *   ->union(self.block.getParticipatingComponents())
		 *   ->asOrderedSet()
		 * else
		 *   self.getParentTestDescription()
		 *   .testConfiguration.componentInstance->asOrderedSet()
		 * endif
		 */
		final /*@NonInvalid*/ Executor executor = PivotUtil.getExecutor(this);
		final /*@NonInvalid*/ IdResolver idResolver = executor.getIdResolver();
		final /*@NonInvalid*/ TestDescription getParentTestDescription = this.getParentTestDescription();
		final /*@NonInvalid*/ SetValue oclAsSet = OclAnyOclAsSetOperation.INSTANCE.evaluate(executor, tdlTables.SET_CLSSid_TestDescription, getParentTestDescription);
		/*@Thrown*/ Object accumulator = ValueUtil.FALSE_VALUE;
		Iterator<Object> ITERATOR_td = oclAsSet.iterator();
		/*@NonInvalid*/ Boolean exists;
		while (true) {
			if (!ITERATOR_td.hasNext()) {
				if (accumulator == ValueUtil.FALSE_VALUE) {
					exists = ValueUtil.FALSE_VALUE;
				}
				else {
					throw (InvalidValueException)accumulator;
				}
				break;
			}
			/*@NonInvalid*/ TestDescription td = (TestDescription)ITERATOR_td.next();
			/**
			 * td.isLocallyOrdered
			 */
			final /*@NonInvalid*/ boolean isLocallyOrdered = td.isIsLocallyOrdered();
			//
			if (isLocallyOrdered) {					// Normal successful body evaluation result
				exists = ValueUtil.TRUE_VALUE;
				break;														// Stop immediately
			}
			else if (!isLocallyOrdered) {				// Normal unsuccessful body evaluation result
				;															// Carry on
			}
			else {															// Impossible badly typed result
				accumulator = new InvalidValueException(PivotMessages.NonBooleanBody, "exists");
			}
		}
		if (exists == null) {
			throw new InvalidValueException("Null if condition");
		}
		/*@NonInvalid*/ OrderedSetValue local_0;
		if (exists) {
			final /*@NonInvalid*/ List<PeriodicBehaviour> periodic = this.getPeriodic();
			final /*@NonInvalid*/ OrderedSetValue BOXED_periodic = idResolver.createOrderedSetOfAll(tdlTables.ORD_CLSSid_PeriodicBehaviour, periodic);
			/*@Thrown*/ Accumulator accumulator_0 = ValueUtil.createSequenceAccumulatorValue(tdlTables.SEQ_CLSSid_ComponentInstance);
			Iterator<Object> ITERATOR__1 = BOXED_periodic.iterator();
			/*@NonInvalid*/ SequenceValue collect;
			while (true) {
				if (!ITERATOR__1.hasNext()) {
					collect = accumulator_0;
					break;
				}
				/*@NonInvalid*/ PeriodicBehaviour _1 = (PeriodicBehaviour)ITERATOR__1.next();
				/**
				 * getParticipatingComponents()
				 */
				final /*@NonInvalid*/ List<ComponentInstance> getParticipatingComponents = _1.getParticipatingComponents();
				final /*@NonInvalid*/ OrderedSetValue BOXED_getParticipatingComponents = idResolver.createOrderedSetOfAll(tdlTables.ORD_CLSSid_ComponentInstance, getParticipatingComponents);
				//
				for (Object value : BOXED_getParticipatingComponents.flatten().getElements()) {
					accumulator_0.add(value);
				}
			}
			final /*@NonInvalid*/ List<ExceptionalBehaviour> exceptional = this.getExceptional();
			final /*@NonInvalid*/ OrderedSetValue BOXED_exceptional = idResolver.createOrderedSetOfAll(tdlTables.ORD_CLSSid_ExceptionalBehaviour, exceptional);
			/*@Thrown*/ Accumulator accumulator_1 = ValueUtil.createSequenceAccumulatorValue(tdlTables.SEQ_CLSSid_ComponentInstance);
			Iterator<Object> ITERATOR__1_0 = BOXED_exceptional.iterator();
			/*@NonInvalid*/ SequenceValue collect_0;
			while (true) {
				if (!ITERATOR__1_0.hasNext()) {
					collect_0 = accumulator_1;
					break;
				}
				/*@NonInvalid*/ ExceptionalBehaviour _1_0 = (ExceptionalBehaviour)ITERATOR__1_0.next();
				/**
				 * getParticipatingComponents()
				 */
				final /*@NonInvalid*/ List<ComponentInstance> getParticipatingComponents_0 = _1_0.getParticipatingComponents();
				final /*@NonInvalid*/ OrderedSetValue BOXED_getParticipatingComponents_0 = idResolver.createOrderedSetOfAll(tdlTables.ORD_CLSSid_ComponentInstance, getParticipatingComponents_0);
				//
				for (Object value : BOXED_getParticipatingComponents_0.flatten().getElements()) {
					accumulator_1.add(value);
				}
			}
			final /*@NonInvalid*/ BagValue union = (BagValue)CollectionUnionOperation.INSTANCE.evaluate(collect, collect_0);
			final /*@NonInvalid*/ List<Block> block = this.getBlock();
			final /*@NonInvalid*/ OrderedSetValue BOXED_block = idResolver.createOrderedSetOfAll(tdlTables.ORD_CLSSid_Block, block);
			/*@Thrown*/ Accumulator accumulator_2 = ValueUtil.createSequenceAccumulatorValue(tdlTables.SEQ_CLSSid_ComponentInstance);
			Iterator<Object> ITERATOR__1_1 = BOXED_block.iterator();
			/*@NonInvalid*/ SequenceValue collect_1;
			while (true) {
				if (!ITERATOR__1_1.hasNext()) {
					collect_1 = accumulator_2;
					break;
				}
				/*@NonInvalid*/ Block _1_1 = (Block)ITERATOR__1_1.next();
				/**
				 * getParticipatingComponents()
				 */
				final /*@NonInvalid*/ List<ComponentInstance> getParticipatingComponents_1 = _1_1.getParticipatingComponents();
				final /*@NonInvalid*/ OrderedSetValue BOXED_getParticipatingComponents_1 = idResolver.createOrderedSetOfAll(tdlTables.ORD_CLSSid_ComponentInstance, getParticipatingComponents_1);
				//
				for (Object value : BOXED_getParticipatingComponents_1.flatten().getElements()) {
					accumulator_2.add(value);
				}
			}
			final /*@NonInvalid*/ BagValue union_0 = (BagValue)CollectionUnionOperation.INSTANCE.evaluate(union, collect_1);
			final /*@NonInvalid*/ OrderedSetValue asOrderedSet = CollectionAsOrderedSetOperation.INSTANCE.evaluate(union_0);
			local_0 = asOrderedSet;
		}
		else {
			final /*@NonInvalid*/ TestConfiguration testConfiguration = getParentTestDescription.getTestConfiguration();
			final /*@NonInvalid*/ List<ComponentInstance> componentInstance = testConfiguration.getComponentInstance();
			final /*@NonInvalid*/ SetValue BOXED_componentInstance = idResolver.createSetOfAll(tdlTables.SET_CLSSid_ComponentInstance, componentInstance);
			final /*@NonInvalid*/ OrderedSetValue asOrderedSet_0 = CollectionAsOrderedSetOperation.INSTANCE.evaluate(BOXED_componentInstance);
			local_0 = asOrderedSet_0;
		}
		final /*@NonInvalid*/ List<ComponentInstance> ECORE_local_0 = ((IdResolverExtension)idResolver).ecoreValueOfAll(ComponentInstance.class, local_0);
		return (EList<ComponentInstance>)ECORE_local_0;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
	{
		switch (featureID) {
			case tdlPackage.MULTIPLE_COMBINED_BEHAVIOUR__BLOCK:
				return ((InternalEList<?>)getBlock()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType)
	{
		switch (featureID) {
			case tdlPackage.MULTIPLE_COMBINED_BEHAVIOUR__BLOCK:
				return getBlock();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue)
	{
		switch (featureID) {
			case tdlPackage.MULTIPLE_COMBINED_BEHAVIOUR__BLOCK:
				getBlock().clear();
				getBlock().addAll((Collection<? extends Block>)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID)
	{
		switch (featureID) {
			case tdlPackage.MULTIPLE_COMBINED_BEHAVIOUR__BLOCK:
				getBlock().clear();
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID)
	{
		switch (featureID) {
			case tdlPackage.MULTIPLE_COMBINED_BEHAVIOUR__BLOCK:
				return block != null && !block.isEmpty();
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eDerivedOperationID(int baseOperationID, Class<?> baseClass)
	{
		if (baseClass == Behaviour.class) {
			switch (baseOperationID) {
				case tdlPackage.BEHAVIOUR___GET_PARTICIPATING_COMPONENTS: return tdlPackage.MULTIPLE_COMBINED_BEHAVIOUR___GET_PARTICIPATING_COMPONENTS;
				default: return super.eDerivedOperationID(baseOperationID, baseClass);
			}
		}
		return super.eDerivedOperationID(baseOperationID, baseClass);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eInvoke(int operationID, EList<?> arguments) throws InvocationTargetException
	{
		switch (operationID) {
			case tdlPackage.MULTIPLE_COMBINED_BEHAVIOUR___GET_PARTICIPATING_COMPONENTS:
				return getParticipatingComponents();
		}
		return super.eInvoke(operationID, arguments);
	}

} //MultipleCombinedBehaviourImpl
